#include "tmEventSetup/esConditionHandle.hh"

#include "tmEventSetup/esCutHandle.hh"
#include "tmEventSetup/esObjectHandle.hh"

#include "tmUtil/tmUtil.hh"

namespace tmeventsetup
{

void
esConditionHandle::print() const
{
  TM_LOG_INF("");
  std::cout << "  name = " << name_ << "\n";
  std::cout << "  type = " << type_ << "\n";
  std::cout << "  # of objects = " << objects_.size() << "\n";
  std::cout << "  # of cuts = " << cuts_.size() << "\n";
  for (const auto& object: objects_) esObjectHandle::print(object);
  for (const auto& cut: cuts_) esCutHandle::print(cut);
}


void
esConditionHandle::addObject(const esObject& object)
{
  objects_.emplace_back(object);
}


void
esConditionHandle::addCut(const esCut& cut)
{
  cuts_.emplace_back(cut);
}


void
esConditionHandle::print(const esCondition& cond)
{
  TM_LOG_INF("");
  std::cout << "  name = " << cond.getName() << "\n";
  std::cout << "  type = " << cond.getType() << "\n";
  const std::vector<esObject>& objects = cond.getObjects();
  std::cout << "  # of objects = " << objects.size() << "\n";
  const std::vector<esCut>& cuts = cond.getCuts();
  std::cout << "  # of cuts = " << cuts.size() << "\n";
  for (const auto& object: objects) esObjectHandle::print(object);
  for (const auto& cut: cuts) esCutHandle::print(cut);
}

} // namespace tmeventsetup
