/**
 * @author      Takashi Matsushita
 * Created:     11 Nov 2015
 */

#ifndef tmEventSetup_esObjectHandle_hh
#define tmEventSetup_esObjectHandle_hh

#include "tmEventSetup/esObject.hh"
#include "tmGrammar/Object.hh"
#include "tmTable/tmTable.hh"

namespace tmeventsetup
{

/**
 *  This class implements data structure for Object
 */
class esObjectHandle : public esObject
{
  public:
    esObjectHandle() = default;

    esObjectHandle(const Object::Item& item);

    esObjectHandle(const Object::Item& item,
                   const tmtable::Table& cuts_in_algo);

    virtual ~esObjectHandle() = default;

    /** initialise the instance with Object::Item instance
     *
     * @param item [in] Object::Item instance */
    void init(const Object::Item& item);

    /** set external channel id
     *
     * @param item [in] external map<name, id>
     */
    void setExternalChannelId(const std::map<std::string, unsigned int>& map);

    /** print the contents of instance */
    void print() const;
    static void print(const esObject& object);
};

} // namespace tmeventsetup

#endif // tmEventSetup_esObjectHandle_hh
